# Tutorial APAP
## Authors
* **Hilmi Al Biruni** - *2006463843* - *APAP-B*

## Tutorial 5
### 1. Apa itu Postman? Apa kegunaannya?

#### Postman adalah sebuah developent tool API yang digunakan untuk build, modify, dan test API. Penggunaan Postman dapat digunakan untuk mendesign, mock, debug, tes, dokumentasi, monitor, dan juga menerbitkan API. Postman memiliki fungsi REST Client yang dapat digunakan untuk menguji REST API.

### 2. Jelaskan fungsi dari anotasi @JsonIgnoreProperties dan @JsonProperty

#### @JsonIgnoreProperties digunnakan untuk memberikan spesifikasi list atribut dari sebuah class yang diabaikan saat menjalankan serialization dan deserialozation JSON. Jika @JsonIgnoreProperties tidak disertakan, nantinya akan menyebabkan error saat menjalankan serialization dan deserialization saat Java Object tidak memiliki field yang ada pada JSON.

### 3. Apa kegunaan atribut WebClient?

#### Kegunaan dari Webclient adalah untuk menghubungkan personal komputer ke jaringan internet yang meminta informasi. Dalam mengakses webserver diperlukan sebuah WebClient untuk menggunakan aplikasi yaitu WebBrowser.

### 4. Apa itu ResponseEntity dan BindingResult? Apa kegunaannya?

#### ResponseEntity merupakan representasi keluruhan HTTP Response dari status code, header, dan body. Dengan demikian, dapat digunakan untuk mengkonfigurasi secara lengkap HTTP response. BindingResult adalah sebuah objek spring yang akan menyimpan hasil validasi, binding, dan error dari model objek yang divalidasikan. Penggunaan BindingResult diletakkan setelah parameter objek divalidasi.

## Tutorial 4
### 1. Jelaskan perbedaan th:include dan th:replace!

#### Perbedaan dari include dan replace adalah penempatan suatu konten dari fragment
#### Include akan memanggil isi dari fragment ke dalam th:include tersebut. Lalu, include akan memasukkan konten fragment tanpa menyisipkan tag fragment itu sendiri.
#### Berbeda dengan include, replace menerapkan konsep parent-kid dalam pengimplementasian fragment tersebut. Replace akan memasukkan konten dari fragment dengan mengganti tag menjadi tag yang mendefinisikan fragment sehingga dapat di kustomisasi.

### 2. Jelaskan apa fungsi dari th:object! 

#### th:object digunakan untuk menyederhanakan pemanggilan suatu objek di dalam HTML. th:object akan menggunakan atribut langsung dari objek tanpa harus menspesifikasikan objek yang dipanggil.

### 3. Jelaskan perbedaan dari * dan $ pada saat penggunaan th:object! Kapan harus dipakai?

#### * digunakan untuk menyatakan sebuah selection dan menunjuk kepada atribut darri suatu objek. Berbeda dengan $ yang digunakan untuk menyatakan sebuah variabel/value dan menunjuk kepada atribut suatu objek.

### 4. Bagaimana parameter/params tersebut bekerja sehingga Anda dapat menambahkan 1 baris penyelenggara pada form tambah course?

#### params perlu dibuat terlebih dahulu logic-nya dalam struktur data List. params akan mendefinisikan semacam "function" agar dapat diimplementasikan di dalam <button> dalam variable "name". 

### 5. Bagaimana parameter/params tersebut bekerja sehingga Anda dapat menghapus 1 baris penyelenggara pada form tambah course?

#### params perlu dibuat terlebih dahulu logic-nya sebagai berikut:
##### final Integer rowId = Integer.valueOf(row);
##### course.getListPengajar().remove(rowId.intValue());
#### Nanti params tersebut akan mendefinisikan semacam "function" agar dapat diimplementasikan di dalam <button> dalam variable "name".

## Tutorial 3
### Pertanyaan 1: Tolong jelaskan secara singkat apa kegunaan dari anotasi-anotasi yang ada pada model (@AllArgsConstructor, @NoArgsConstructor, @Setter, @Getter, @Entity, @Table)
#### @AllArgsConstructor digunakan untuk menghasilkan constructor pada semua field pada class dengan suatu parameter.
#### @NoArgsConstructor digunakan untuk menghasilkan no-args constructor yang akan menghasilkan pesan error jika constructor terseebut tidak dapat ditulis karena adanya final fields
#### @Setter dan @Getter digunakan untuk mempermudah generate setter dan getter sehingga tidak perlu membuat manual, hanya memanggil get dan set saja.
#### @Entity digunakan untuk mewakili data yang akan disimpan didalam database
#### @Table digunakan untuk menentukan nama table database yang nantinya digunakan sebagai pemetaan
#### Referensi : https://javabydeveloper.com/lombok-allargsconstructor-examples/ https://projectlombok.org/api/lombok/NoArgsConstructor.html

### Pertanyaan 2: Pada class CourseDb, terdapat method findByCodeUsingQuery dan findByCode, apakah perbedaan kedua method tersebut? Jelaskan juga kegunaan @Query pada method findByCodeUsingQuery! 

#### Pada findByCode tidak menggunakan @Query sedangkan pada findByCodeUsingQuery menggunakan @Query. @Query digunakan untuk mengimplementasikan command MySQL pada interface dan menghubungkannya ke database sehingga akan menjadi @Query("SELECT.....") lalu diikuti dengan  findByCodeUsingQuery

### Pertanyaan 3: Jelaskan perbedaan kegunaan dari anotasi @JoinTable dan @JoinColumn
#### @JoinTable menyimpan id dari kedua entity ke tabel yang terpisah. Penggunaan @JoinTable ketika kita ingin mengatur hubungan antara entity dengan table lain.

#### Sedangkan @JoinColumn menyimpan id dari entity lain di column baru di tabel yang sama. Penggunaan @JoinColumn ketika entity memiliki direct relationship seperti foreign key antara dua entity.

### Pertanyaan 4: Pada class Pengajar, digunakan anotasi @JoinColumn pada atribut Course, apa kegunaan dari name, referencedColumnName, dan nullable dalam anotasi tersebut? dan apa perbedaan nullable dan penggunaan anotasi @NotNull
Pada @JoinColumn di atribut Course, name berguna untuk menyatakan nama dari foreign key column. Lalu, referencedColumnName berguna untuk mencari nama dari column yang direferensi oleh foreign key column. Kemudian, nullable untuk menyatakan apakah foreign key kolomnya null atau tidak. Perbedaan dari nullable dengan anotasi @NotNull adalah nullable hanya menambahkan batasan null yang true / false ke definisi tabel, sedangkan anotasi @NotNull memeriksa apakah atributnya bukan null.


### Pertanyaan 5: Jelaskan kegunaan FetchType.LAZY, CascadeType.ALL, dan FetchType.EAGER
#### FetchType.LAZY berisi seluruh data java object yang telah di-fetch saat dibutuhkan atau saat memanggil datanya (LAZY). FetchType biasanya digunakan di relasi many-to-many atau one-to-many.

#### CascadeType.All berguna supaya segala perubahan yang ada pada suatu entity akan terjadi juga pada entity seluruh anaknya/child. Perubahan terjadi saat ada delete, update, dan lainnya.

#### FetchType.EAGER berisi seluruh data java objects yang telah di-fetch langsung. fetchtype ini akan melakukan fetch-nya diawal. Berbeda dengan tipe LAZY, tipe ini digunakan untuk relasi many-to-one atau one-to-one.







## Tutorial 2
### Pertanyaan 1: Cobalah untuk menambahkan sebuah Course dengan mengakses link berikut: http://localhost:8080/course/add?code=APAP&nameCourse=APAP%20Tutorial2&description=2020%20Fasilkom&jumlahSks=3 Apa yang terjadi? Jelaskan mengapa hal tersebut dapat terjadi?
Jika link tersebut diakses akan memunculkan Whitelabel Error Page Service Error 500. Hal ini dikarenakan sudah ada perintah return "add-course" pada controller. Controller merupakan file yang berfungsi untuk melakukan mapping dari request yang diinput, kemudian akan diminta untuk memanggil template html yang akan direturn. Sedangkan html "add-course" belum dibuat, sehingga hal ini akan menyebabkan error.

### Pertanyaan 2: Menurut kamu anotasi @Autowired pada class Controller tersebut merupakan implementasi dari konsep apa? Dan jelaskan secara singkat cara kerja @Autowired tersebut dalam konteks service dan controller yang telah kamu buat
 Anotasi @Autowired pada Controller merupakan implementasi dari konsep dependancy injection. @Autowired dapat memasukkan dependensi objek secara implisit. Sehingga, @Autowired pada CourseController tidak perlu dibuat constructor, setter, dan getter. Hal ini dikarenakan @Autowired otomatis mencari service yang mengimplementasikan interface CourseService.

### Pertanyaan 3: Cobalah untuk menambahkan sebuah Course dengan mengakses link berikut: http://localhost:8080/course/add?code=APAP&nameCourse=APAP%20Tutorial2&jumlahSks=3   Apa yang terjadi? Jelaskan mengapa hal tersebut dapat terjadi.
Jika link tersebut diakses akan memunculkan Whitelabel Error Page type=Bad Request status=400. Hal ini dikarenakan suatu parameter tidak dicantumkan. Sedangkan seluruh atribut harus terisi dan tidak boleh null.

### Pertanyaan 4: Jika Papa APAP ingin melihat Course dengan kode APAP, link apa yang harus diakses?
http://localhost:8080/course/view?code=APAP 

### Pertanyaan 5: Tambahkan 1 contoh Course lainnya sesukamu. Lalu cobalah untuk mengakses http://localhost:8080/course/viewAll  , apa yang akan ditampilkan? Sertakan juga bukti screenshotmu. 
Akan bertambah course lain

https://drive.google.com/file/d/1NGZj0VJENBv4pRQjVcsHjZRmML3h7E9O/view?usp=sharing


## Tutorial 1
### What I have learned today
Pada tutorial ini, saya mempelajari tentang cara mengoperasikan Git secara lebih advance. Sebelumnya, saya pernah melakukan hal berikut saat mengerjakan TK Basdat oleh teman saya dari Ilmu Komputer. Lalu, saya juga baru memahami secara dasar tentang Java Springboot. 
### GitLab
1. Apa itu Issue Tracker? Apa saja masalah yang dapat diselesaikan dengan Issue Tracker?
#### Issue Tracker adalah fitur Gitlab yang akan menandakan letak isu yang terjadi saat mengoperasikan git. Masalah umum seperti commit, branch, merge, dan lain-lain akan dinotice oleh Issue Tracker
2. Apa perbedaan dari git merge dan git merge --squash?
#### git merge hanya melakukan merging git, sedangkan git merge --squash seperti merging yang simpel yang tidak akan membuat commit di dalam history branch
3. Apa keunggulan menggunakan Version Control System seperti Git dalam pengembangan
suatu aplikasi?
#### Menggunakan Git akan mempermudah dalam mengorganize repository. Git juga sudah sangat familiar oleh banyak orang sehingga tidak akan susah dalam menggunakan Git
### Spring
4. Apa itu library & dependency?
#### Library dan dependency adalah sesuatu yang berkaitan tetapi tidak sama. Kode pada library akan menjadi sebuah dependency ketika project lain digunakan, dan tidak akan menjadi dependency oleh project yang lain.
5. Apa itu Gradle? Mengapa kita menggunakan Gradle? Apakah ada alternatif dari Gradle?
#### Gradle adalah sebuah program yang berfungsi untuk melakukan build secara otomatis. Karena itu, Gradle sering disebut sebagai build-tool. Alasan menggunakan Gradle adalah agar pekerjaan dalam melakukan build akan dapat otomatis dilakukan. Aplikasi alternatif dari Gradle adalah CMake, SCons, GNU Make, Maven, Meson, Buck, Ant, Cake, Rake, dan SBT.
6. Selain untuk pengembangan web, apa saja yang bisa dikembangkan dengan Spring
framework?
#### Bisa digunakan untuk mengembangkan enterprise
7. Apa perbedaan dari @RequestParam dan @PathVariable? Kapan sebaiknya menggunakan @RequestParam atau @PathVariable?
#### @RequestParam digunakan untuk membaca data formulir HTML yang disediakan oleh pengguna dan mengikatnya ke parameter permintaan.
#### @Pathvariable: Anotasi ini digunakan untuk menangani variabel template dalam pemetaan URI permintaan, dan menggunakannya sebagai parameter metode
#### @RequestParam digunakan jika anotasi parameter belum ditentukan, @Pathvariable digunakan jika parameter sudah ada
### What I did not understand
(tuliskan apa saja yang kurang Anda mengerti, Anda dapat men-_check_ apabila Anda
sudah mengerti dikemudian hari, dan tambahkan tulisan yang membuat Anda mengerti)
- [ ] Lorem ipsum dilor
- [x] Lorem ipsum dilor
